<?php
################################################################################
# @Name : ./core/export_tickets.php
# @Desc : dump csv files of current query
# @call : /stat.php
# @parameters : 
# @Author : Flox
# @Create : 27/01/2014
# @Update : 24/11/2016
# @Version : 3.1.13
################################################################################

//initialize variables 
if(!isset($_GET['token'])) $_GET['token'] = 'XXX'; 

//database connection
require "../connect.php"; 

//get last token
$query = $db->query("SELECT token FROM `ttoken` ORDER BY id DESC LIMIT 1");
$token=$query->fetch(); 
$query->closeCursor();

//truncate table
$query = $db->query("TRUNCATE TABLE `ttoken`");

//secure connect from athenticated user
if ($token['token']==$_GET['token'])
{
	//get current date
	$daydate=date('Y-m-d');

	// output headers so that the file is downloaded rather than displayed
	header("Content-Type: text/csv; charset=utf-8");
	header("Content-Disposition: attachment; filename=\"$daydate-GestSup-export-tickets.csv\"");

	//load parameters table
	$qparameters = $db->query("SELECT * FROM `tparameters`"); 
	$rparameters= $qparameters->fetch();
	$qparameters->closeCursor();

	//create a file pointer connected to the output stream
	$output = fopen('php://output', 'w');

	//output the column headings
	fprintf($output, chr(0xEF).chr(0xBB).chr(0xBF));
	fputcsv($output, array('Numéro du ticket', 'Type', 'Technicien', 'Demandeur', 'Service', 'Société', 'Créateur', 'Catégorie', 'Sous Catégorie','Titre', 'Temps passé', 'Date de création','Date de résolution estimé', 'Date de clôture', 'État', 'Priorité', 'Criticité'),";");

	//fetch the data
	$query = $db->query('SELECT id,type,technician,user,u_service,img1,creator,category,subcat,title,time,date_create,date_hope,date_res,state,priority,criticality FROM tincidents WHERE disable=0');

	//loop over the rows, outputting data in field
	while ($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		
		//detect technician group to display group name instead of technician name
		if ($row['technician']==0)
		{
			//check if group exist on this ticket
			$query2=$db->query("SELECT * FROM tincidents WHERE id='$row[id]'");
			$row2=$query2->fetch();
			$query2->closeCursor(); 
			if ($row2['t_group']!='0')
			{
				//get group name
				$query2=$db->query("SELECT * FROM tgroups WHERE id='$row2[t_group]'");
				$row2=$query2->fetch();
				$query2->closeCursor(); 
				$row['technician']="$row2[name]";
			}
		} else {
			$querytech=$db->query("SELECT firstname,lastname FROM tusers WHERE id LIKE '$row[technician]' "); 
			$resulttech=$querytech->fetch();
			$querytech->closeCursor(); 
			$row['technician']="$resulttech[firstname] $resulttech[lastname]";
		}
		
		$querytype=$db->query("SELECT name FROM ttypes WHERE id LIKE $row[type]"); 
		$resulttype=$querytype->fetch();
		$querytype->closeCursor(); 
		$row['type']=$resulttype['name'];
		
		$querycompany=$db->query("SELECT name FROM tcompany,tusers WHERE tusers.company=tcompany.id and tusers.id LIKE '$row[user]'"); 
		$resultcompany=$querycompany->fetch();
		$querycompany->closeCursor(); 
		$row['img1']="$resultcompany[name]";
		
		//detect user group to display group name instead of user name
		if ($row['user']=='')
		{
			//check if group exist on this ticket
			$query2=$db->query("SELECT * FROM tincidents WHERE id='$row[id]'");
			$row2=$query2->fetch();
			$query2->closeCursor(); 
			if ($row2['u_group']!='0')
			{
				//get group name
				$query2=$db->query("SELECT * FROM tgroups WHERE id='$row2[u_group]'");
				$row2=$query2->fetch();
				$query2->closeCursor(); 
				$row['user']="$row2[name]";
			}
		} else {
			$queryuser=$db->query("SELECT firstname,lastname FROM tusers WHERE id LIKE '$row[user]'"); 
			$resultuser=$queryuser->fetch();
			$queryuser->closeCursor(); 
			$row['user']="$resultuser[firstname] $resultuser[lastname]";
		}
		
		$queryservice=$db->query("SELECT name FROM tservices WHERE id LIKE '$row[u_service]'"); 
		$resultservice=$queryservice->fetch();
		$queryservice->closeCursor(); 
		$row['u_service']="$resultservice[name]";
		
		$querycreator=$db->query("SELECT firstname,lastname FROM tusers WHERE id LIKE '$row[creator]'"); 
		$resultcreator=$querycreator->fetch();
		$querycreator->closeCursor(); 
		$row['creator']="$resultcreator[firstname] $resultcreator[lastname]";
		
		$querycat=$db->query("SELECT * FROM tcategory WHERE id LIKE '$row[category]'"); 
		$resultcat=$querycat->fetch();
		$querycat->closeCursor(); 
		$row['category']=$resultcat['name'];
		
		$queryscat=$db->query("SELECT * FROM tsubcat WHERE id LIKE '$row[subcat]'"); 
		$resultscat=$queryscat->fetch();
		$queryscat->closeCursor(); 
		$row['subcat']=$resultscat['name'];
		
		$querystate=$db->query("SELECT * FROM tstates WHERE id LIKE $row[state]"); 
		$resultstate=$querystate->fetch();
		$querystate->closeCursor(); 
		$row['state']=$resultstate['name'];

		$querypriority=$db->query("SELECT * FROM tpriority WHERE number LIKE $row[priority]"); 
		$resultpriority=$querypriority->fetch();
		$querypriority->closeCursor(); 
		$row['priority']=$resultpriority['name'];
		
		$querycriticality=$db->query("SELECT * FROM tcriticality WHERE id LIKE $row[criticality]"); 
		$resultcriticality=$querycriticality->fetch();
		$querycriticality->closeCursor(); 
		$row['criticality']=$resultcriticality['name'];
		
		fputcsv($output, $row,';');
	}
} else {
	echo "<font color=\"red\"><b>Acc&egrave;s a cette page interdite, contactez votre administrateur.</b></font>";	
}
$db = null;
?>